#ifndef __MODEL_H
#define __MODEL_H

#include <iostream>
#include <vector>
#include "../punkt2d.h"
#include "../punkt3d.h"
#include "../gltexture.h"
// #include "load3ds.h"

class ModelObject {
	friend class Load3ds;
	private:
		std::vector<Punkt3D> normal;
		std::vector<Punkt3D> vertex;
		std::vector<Punkt2D> mapcoord;
		std::vector<Punkt3D> polygon;
		void calcNormales();
		std::string name;
	public:
		ModelObject();
		
		void render();
		void clear();
	
};

class Model {
	private:
		std::vector<ModelObject> objects;
		
		
	public:
		Model();
		void addObject(ModelObject c);
		void clear();
		void render();
};

#endif
